.include "global.inc"
.export draw_controller_name

LF = 10

.rodata
; order must correspond to TYPE_* constants in global.inc
controller_names:
  .addr nes_name, dogbone_name
  .addr fc_i_name, fc_ii_name
  .addr fourscore_name, zapper_name
  .addr nesvaus_name, powerpad_name
  .addr snes_name, mouse_name

.assert * = controller_names + 2 * NUM_PADNAMES, error, "wrong short description count for NUM_PADNAMES"

; Each controller has 3 lines of text, each up to 13 characters.
; Lines 1 and 2 describe the controller; line 3 asks to press
; a button to test that controller.
nes_name:       .byte "NES",LF,"Controller",LF,"Press A",0
dogbone_name:   .byte "NES Dogbone",LF,"Controller",LF,"Press A",0
fc_i_name:      .byte "Famicom",LF,"Controller",LF,"Press A",0
fc_ii_name:     .byte "Famicom Mic",LF,"Controller",LF,"Press A",0
fourscore_name: .byte "Four Score/",LF,"Satellite",LF,"Press 1:A",0
zapper_name:    .byte "Zapper",LF,LF,"Pull trigger",0
nesvaus_name:   .byte "NES Arkanoid",LF,"Controller",LF,"Press Fire",0
powerpad_name:  .byte "Power Pad",LF,LF,"Press 4",0
snes_name:      .byte "Super NES",LF,"Controller",LF,"Press B",0
mouse_name:     .byte "Super NES",LF,"Mouse",LF,"Press Left",0

.code
CONTROLLER_NAME_X = 144

;;
; @param A controller type
; @param Y vertical position in 16-pixel increments
; @param $04 number of text lines to draw (2 or 3)
.proc draw_controller_name
dstlo = $02
numlines = $04
  asl a
  tax
  jsr seek_nt_line_y
  ora #CONTROLLER_NAME_X >> 3
  sta dstlo
  lda controller_names+1,x
  ldy controller_names+0,x
  jmp puts_multiline_16
.endproc

BITS_NAME_X = 16
;;
; @param A controller bits
; @param Y vertical position in 16-pixel increments
.proc draw_controller_bits
controller_bits = $00
dstlo = $02
numlines = $04
  sta controller_bits
  jsr seek_nt_line_y
  ora #BITS_NAME_X >> 3
  sta dstlo
  lda #2
  sta numlines
  lsr a
  and controller_bits
  adc #'1'
  sta PB53_outbuf+0
  lda #'P'
  sta PB53_outbuf+1
  lda #LF
  sta PB53_outbuf+2
  lda #' '
  sta PB53_outbuf+3
  lda #'D'
  sta PB53_outbuf+4
  lda controller_bits
  and #$E0
  asl a
  rol a
  rol a
  rol a
  ora #'0'
  sta PB53_outbuf+5
  lda #0
  sta PB53_outbuf+6
  sta PB53_outbuf+8
  lda controller_bits
  asl a
  asl a
  asl a
  eor controller_bits
  and #$E0
  beq not_range
    lda #'-'
    sta PB53_outbuf+6
    lda controller_bits
    and #$1C
    lsr a
    lsr a
    ora #'0'
    sta PB53_outbuf+7
  not_range:

  lda #>PB53_outbuf
  ldy #<PB53_outbuf
  jmp puts_multiline_16
  rts
.endproc
